package de.ipk_gatersleben.ag_nw.centilib.centralities;

import org.apache.commons.collections15.Transformer;

import edu.uci.ics.jung.algorithms.scoring.PageRank;
import edu.uci.ics.jung.graph.Graph;

public class CentiLibPageRank<V, E> extends VertexCentrality<V,E> {
	
	private PageRank<V,E> pageRank;
	
	public CentiLibPageRank(Graph<V, E> graph,
			Transformer<E, ? extends Number> edgeWeight, double alpha) {
		super("PageRank",graph);
		this.pageRank = new PageRank<V,E>(graph, edgeWeight, alpha);
		// TODO Auto-generated constructor stub
	}

	public CentiLibPageRank(Graph<V, E> graph, double alpha) {
		super("PageRank",graph);
		this.pageRank = new PageRank<V,E>(graph, alpha);
		// TODO Auto-generated constructor stub
	}

	@Override
	public Double getVertexScore(V v) {
		return pageRank.getVertexScore(v);
	}
	public void setMaxIterations(int iterations){
		pageRank.setMaxIterations(iterations);
	}
	
	public int getMaxIterations(){
		return pageRank.getMaxIterations();
	}
	
	public int getIterations(){
		return pageRank.getIterations();
	}
	
	public double getTolerance(){
		return pageRank.getTolerance();
	}
	public void setTolerance(Double tolerance){
		pageRank.setTolerance(tolerance);
	}
	
	public void evaluate(){
		pageRank.evaluate();
	}

}
