package de.ipk_gatersleben.ag_nw.centilib.centralities;

import edu.uci.ics.jung.graph.Graph;

/**
 * 
 * @author Johannes Graessler
 * @param <V>
 * @param <E>
 */
public class InOutDegree<V,E> extends VertexCentrality<V,E> {

    protected boolean useInDegree = true;

    public InOutDegree(Graph<V,E> graph){
    	this(graph,true);
    }
    
    public InOutDegree(Graph<V,E> graph, boolean useInDegree){
    	super("Degree",graph);
    	if(useInDegree)
    		this.name = "In-"+this.name;
    	else
    		this.name = "Out-"+this.name;
    	
    	this.useInDegree = useInDegree;
    }
    
	@Override
	public Double getVertexScore(V v) {
		int degree;
		if(useInDegree)
			degree= graph.inDegree(v);
		else
			degree = graph.outDegree(v);
		output.put(v, Double.valueOf(Integer.toString(degree)));
		return output.get(v);
	}

}
