package de.ipk_gatersleben.ag_nw.centilib.centralities.parameter;

import de.ipk_gatersleben.ag_nw.centilib.CentiLib;
import de.ipk_gatersleben.ag_nw.centilib.utils.GraphCachingUtils;
import edu.uci.ics.jung.graph.Graph;

public class PageRankParameter extends CentralityParameter {

	private CentiLib<?,?> centilib;
	
	private String graphName;
	
	public PageRankParameter(CentiLib<?,?> centilib, Graph<?,?> graph){
		
		graphName = GraphCachingUtils.getGraphName(graph);
		this.centilib = centilib;
	}
	
	@Override
	protected Double askForValue() {
		if(centilib == null)
			return null;
		
		return centilib.askForDouble("PageRank for Graph: " + graphName + "\n\nPlease enter a bias value.", "0.15", 0, 1);
	}

	@Override
	public Double getMinValue(){
		return 0.0;
	}
	
	@Override
	public Double getMaxValue(){
		return 1.0;
	}
}
