package de.ipk_gatersleben.ag_nw.centilib.gui;

import java.util.Collection;

import javax.swing.JTabbedPane;

import de.ipk_gatersleben.ag_nw.centilib.CentiLib;
import de.ipk_gatersleben.ag_nw.centilib.centralities.VertexCentrality;
import de.ipk_gatersleben.ag_nw.centilib.plugin.ApplicationInterface;
import edu.uci.ics.jung.graph.Graph;

@SuppressWarnings("serial")
public class CentiLibPanel<V,E> extends JTabbedPane {

	private GraphStatisticsPanel<V,E> statisticsPanel;
	
	private ResultPanel<V,E> resultPanel;
	
	private AssistancePanel<V,E> assistPanel;
	
	private ApplicationInterface<V,E> application;
	
	public CentiLibPanel(CentiLib<V,E> centilib) {
		
		application = centilib.getAppInterface();
		
		resultPanel  = new ResultPanel<V,E>(centilib);
		addTab("Results", resultPanel);

		statisticsPanel = new GraphStatisticsPanel<V,E>(centilib);
		addTab("Graph Statistics",statisticsPanel);
		
		assistPanel = new AssistancePanel<V, E>(centilib);
		addTab("Assistance", assistPanel);
		
	}
	
	public void setGraph(Graph<V,E> graph){
		
		application.updateGraphList();
		resultPanel.setStatus(graph);
		statisticsPanel.setGraph(graph);
		assistPanel.updateGraphs();
		validate();
	}
	
	public void setRanker(VertexCentrality<V,E> scorer, String name){
		resultPanel.setScorer(scorer,name);
	}
	
	public Collection<V> getSelectedVertices(){
		return resultPanel.getSelectedVertices();
	}
	
	public void setSelectedVertices(Collection<V> selected){
		resultPanel.setSelectedVertices(selected);
	}
    public void setOperationString(String s) {
    	assistPanel.setOperationString(s);
    }

    public void setProgressString(String s) {
        assistPanel.setProgressString(s);
    }

    public void startProgressBar() {
        assistPanel.startProgressBar();
    }	
    
    public void stopProgressBar(){
    	assistPanel.stopProgressBar();
    }
	
}
