package de.ipk_gatersleben.ag_nw.centilib.gui;

import java.util.ArrayList;
import java.util.Set;

import javax.swing.table.AbstractTableModel;

import org.apache.commons.collections15.BidiMap;

import edu.uci.ics.jung.algorithms.util.Indexer;

@SuppressWarnings("serial")
public class ConnectedComponentTableModel<V> extends AbstractTableModel {

	String listName = "elements";
	BidiMap<Set<V>, Integer> output = Indexer.create(new ArrayList<Set<V> >());
	
	public ConnectedComponentTableModel(Set<Set<V>> elements){
		
		int maxValue = Integer.MIN_VALUE;
		Set<V> maxElement = null;

		// very simple(slow) sorting, but there are only a few expected (<1000)
		for (int i = 0; i < elements.size(); i++) {
			for (Set<V> d : elements) {
				if (output.containsKey(d))
					continue;
				if (d.size() > maxValue) {
					maxElement = d;
					maxValue = d.size();
				}
			}
			maxValue = Integer.MIN_VALUE;
			output.put(maxElement,i);
		}
	}

	@Override
	public int getColumnCount() {
		return 1;
	}

	@Override
	public int getRowCount() {
		return output.size();
	}

	@Override
	public Object getValueAt(int rowIndex, int columnIndex) {
		if(output.getKey(rowIndex) == null){
			System.out.println("groesse:" +output.size() + "\tgesucht:"+rowIndex);
			return rowIndex;
			
		}
		return Integer.toString(output.getKey(rowIndex).size());
	}
	
	public Set<V> getCompAtPos(int rowIndex){
		return output.getKey(rowIndex);
	}

	@Override
	public String getColumnName(int col){
		return "Components - Sorted by size";
	}
}
