package de.ipk_gatersleben.ag_nw.centilib.gui;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

import javax.swing.table.AbstractTableModel;

import org.apache.commons.collections15.Transformer;

@SuppressWarnings("serial")
public class ListTableModel<T> extends AbstractTableModel {

	private Map<Integer, T> output = new HashMap<Integer,T>();
	
	private Transformer<T, String> toString;
	
	private String listName = "";
	
	
	public ListTableModel(Collection<T> list, String listName, Transformer<T,String> toString) {
		super();
		
		if(toString == null){
			this.toString = new Transformer<T, String>(){
				public String transform(T o){
					return "default";
				}
			};
		}
		else this.toString = toString;
		
		if(listName == null) this.listName = "elements";
		else this.listName = listName;
		if(list == null || list.size() == 0){
			return;
		}
		
		int index = 0;
		for(T o : list){
			output.put(index, o);
			index++;
		}	
	}

	@Override
	public int getColumnCount() {
		return 1;
	}

	@Override
	public int getRowCount() {
		// TODO Auto-generated method stub
		
		return output.size();
	}

	@Override
	public Object getValueAt(int rowIndex, int columnIndex) {
		// TODO Auto-generated method stub
		if(output == null) return "";
		return toString.transform(output.get(rowIndex));
	}
	
	public T getItemAt(int rowIndex, int columnIndex){
		if(output == null) return null;
		return output.get(rowIndex);
	}

	@Override
	public String getColumnName(int pos){
		return "";//listName;
	}
}
