package de.ipk_gatersleben.ag_nw.centilib.gui.actions;

import java.awt.event.ActionEvent;

import javax.swing.Action;
import javax.swing.Icon;

import de.ipk_gatersleben.ag_nw.centilib.CentiLib;
import de.ipk_gatersleben.ag_nw.centilib.utils.ErrorHandler;

/**
 * Execution of an action, synchonously.
 *
 * @author Johannes Graessler 
 * @author Dirk Koschuetzki
 */
public abstract class CentiLibSynchronousAction<V,E> extends CentiLibAction<V,E> {

    public CentiLibSynchronousAction(CentiLib<V,E> centibin, String name) {
        super(centibin, name);
    }

    public CentiLibSynchronousAction(CentiLib<V,E> centibin, String name, Icon icon) {
        super(centibin, name, icon);
    }

    public void actionPerformed(ActionEvent e) {

        // Running on the Event Thread !!!
        try {
            getCentiLib().startLongRunningOperation((String) getValue(Action.NAME), CentiLib.WAIT_STRING);
            doItSynchronous(e);
        } catch (Exception exc) {
            getCentiLib().holdLongRunningOperation("Exception catched", "Please confirm the dialog...");
            ErrorHandler.getInstance().exceptionCatched(exc);
            getCentiLib().continueLongRunningOperation();
        } finally {
            getCentiLib().finishedLongRunningOperation();
        }
    }

    protected abstract void doItSynchronous(ActionEvent e) throws Exception;

}