package de.ipk_gatersleben.ag_nw.centilib.gui.actions;

import java.util.Set;

import de.ipk_gatersleben.ag_nw.centilib.utils.GraphCachingUtils;
import edu.uci.ics.jung.graph.Graph;

public class ConnectedComponents<V,E> {

	private Set<Set<V> > nodes;
	
	private Set<Set<V> > edges;
	
	private Graph<V,E> graph;
	
	public ConnectedComponents(Graph<V,E> graph, Set<Set<V> > nodes){
		
		this.nodes = nodes;
		this.graph = graph;
	}
	
	public Set<Set<V> > getComponents(){
		return nodes;
	}
	
	public Set<E> getEdges(Set<V> component){
		return GraphCachingUtils.getEdgesOfComponent(graph, component);
	}
	
	public Graph<V,E> getGraph(){
		return graph;
	}
}
