package de.ipk_gatersleben.ag_nw.centilib.gui.actions;

import de.ipk_gatersleben.ag_nw.centilib.CentiLib;

/**
 * 
 * @author Johannes Graessler
 *
 * @param <V>
 * @param <E>
 */
public abstract class IterativeCentralityAction<V,E> extends CentralityAction<V, E> {

	public static final double TOLERANCE = 0.0000001;
	
	public IterativeCentralityAction(CentiLib<V,E> centibin, String name) {
		super(centibin,name);
	}
	
	protected int getNumberOfIterations(){
		String question = "The number of maximum iterations is reached, but the "+this.scorerName+"-Algorithm didn't" +
				" finish\n with the desired accuracy("+IterativeCentralityAction.TOLERANCE +")." +
				"\n\nPlease type the number of iterations to do (0 to cancel).";
		Integer iterations = getCentiLib().askForInteger(question, "50");
		if(iterations == null)
			return 0;
		else
			return iterations;
	}
}
