package de.ipk_gatersleben.ag_nw.centilib.gui.actions.centralities;

import org.apache.commons.collections15.Transformer;

import de.ipk_gatersleben.ag_nw.centilib.CentiLib;
import de.ipk_gatersleben.ag_nw.centilib.centralities.BrandesCloseness;
import de.ipk_gatersleben.ag_nw.centilib.centralities.BrandesSP;
import de.ipk_gatersleben.ag_nw.centilib.centralities.VertexCentrality;
import de.ipk_gatersleben.ag_nw.centilib.gui.actions.CentralityAction;
import de.ipk_gatersleben.ag_nw.centilib.utils.CentralityHandler;
import edu.uci.ics.jung.graph.Graph;

/**
 * Computes the Closeness centrality.
 *
 * @author Johannes Graessler 
 * @author Dirk Koschuetzki
 */
public class ClosenessCentralityAction<V,E> extends CentralityAction<V,E> {

    public ClosenessCentralityAction(CentiLib<V,E> centibin) {
        super(centibin, "*** Closeness");
        this.scorerName = CentralityHandler.CLOSENESS;
    }

     public static <V,E> VertexCentrality<V,E> calculateCloseness(Graph<V,E> graph, Transformer<E, ? extends Number> edgeWeights) {
    	 
    	 BrandesCloseness<V,E> bcl = new BrandesCloseness<V,E>(graph);
    	 BrandesSP<V,E> brandes = new BrandesSP<V,E>(graph,edgeWeights);
    	  
    	 brandes.addListener(bcl);
    	 brandes.start();
/*  	 Closeness<V,E> cls = new Closeness<V,E>(graph,distance);
    	 for(V v : graph.getVertices())
    		 cls.getVertexScore(v);
  */  		 
    	 return bcl;
    }
}