package de.ipk_gatersleben.ag_nw.centilib.gui.actions.centralities;

import de.ipk_gatersleben.ag_nw.centilib.CentiLib;
import de.ipk_gatersleben.ag_nw.centilib.centralities.CurrentFlowBetweenness;
import de.ipk_gatersleben.ag_nw.centilib.gui.actions.CentralityAction;
import de.ipk_gatersleben.ag_nw.centilib.utils.CentralityHandler;
import de.ipk_gatersleben.ag_nw.centilib.utils.GraphCachingUtils;
import edu.uci.ics.jung.graph.Graph;

/**
 * Computes the current flow betweenness.
 *
 * @author Johannes Graessler 
 * @author Dirk Koschuetzki
 * @author Michael Telgkamp
 */
@SuppressWarnings("serial")
public class CurrentFlowBetweennessCentralityAction<V,E> extends CentralityAction<V,E> {

    public CurrentFlowBetweennessCentralityAction(CentiLib<V,E> centibin) {
        super(centibin, "*** Current-Flow Betweenness");
        this.scorerName = CentralityHandler.CURRENTFLOWBETWEENNESS;
    }

    public static <V,E> CurrentFlowBetweenness<V,E> calculateCurrentFlowBetweenness(Graph<V,E> graph) {
        CurrentFlowBetweenness<V,E> cfc = new CurrentFlowBetweenness<V,E>(graph,GraphCachingUtils.getEdgeWeights(graph));
        cfc.getVertexScore(graph.getVertices().iterator().next());
        return cfc;
    }

}