package de.ipk_gatersleben.ag_nw.centilib.gui.actions.centralities;

import de.ipk_gatersleben.ag_nw.centilib.CentiLib;
import de.ipk_gatersleben.ag_nw.centilib.centralities.CurrentFlowCloseness;
import de.ipk_gatersleben.ag_nw.centilib.gui.actions.CentralityAction;
import de.ipk_gatersleben.ag_nw.centilib.utils.CentralityHandler;
import de.ipk_gatersleben.ag_nw.centilib.utils.GraphCachingUtils;
import edu.uci.ics.jung.graph.Graph;

/**
 * Computes the current flow closeness.
 *
 * @author Johannes Graessler 
 * @author Dirk Koschuetzki
 * @author Michael Telgkamp
 */
public class CurrentFlowClosenessCentralityAction<V,E> extends CentralityAction<V,E> {

    public CurrentFlowClosenessCentralityAction(CentiLib<V,E> centibin) {
        super(centibin, "*** Current-Flow Closeness");
        scorerName = CentralityHandler.CURRENTFLOWCLOSENESS;
    }

    public static <V,E> CurrentFlowCloseness<V,E> calculateCurrentFlowCloseness(Graph<V,E> graph) {
        CurrentFlowCloseness<V,E> cfc = new CurrentFlowCloseness<V,E>(graph,GraphCachingUtils.getEdgeWeights(graph));
        cfc.getVertexScore(graph.getVertices().iterator().next());
        return cfc;
    }

}