package de.ipk_gatersleben.ag_nw.centilib.gui.actions.centralities;

import org.apache.commons.collections15.Transformer;

import de.ipk_gatersleben.ag_nw.centilib.CentiLib;
import de.ipk_gatersleben.ag_nw.centilib.centralities.BrandesEccentricity;
import de.ipk_gatersleben.ag_nw.centilib.centralities.BrandesSP;
import de.ipk_gatersleben.ag_nw.centilib.centralities.VertexCentrality;
import de.ipk_gatersleben.ag_nw.centilib.gui.actions.CentralityAction;
import de.ipk_gatersleben.ag_nw.centilib.utils.CentralityHandler;
import edu.uci.ics.jung.graph.Graph;

/**
 * Computes the eccentricity centrality.
 *
 * @author Johannes Graessler 
 * @author Dirk Koschuetzki
 */
public class EccentricityCentralityAction<V,E> extends CentralityAction<V,E> {

	public EccentricityCentralityAction(CentiLib<V,E> centibin) {
		super(centibin, "*** Eccentricity");
		scorerName = CentralityHandler.ECCENTRICITY;
	}

	public static <V,E> VertexCentrality<V,E> calculateEccentricity(Graph<V,E> graph, Transformer<E, ? extends Number> edgeWeights) {
		
		BrandesSP<V,E> brandes;
		BrandesEccentricity<V, E> becc = new BrandesEccentricity<V, E>(graph);
		
		if(edgeWeights == null)
			brandes = new BrandesSP<V,E>(graph);
		else
			brandes = new BrandesSP<V,E>(graph,edgeWeights);
		
		brandes.addListener(becc);
		brandes.start();
    	 	
/*		Eccentricity<V,E> ecc = new Eccentricity<V,E>(graph,distance);
		for(V v : graph.getVertices())
			ecc.getVertexScore(v);
*/
		return becc;
	}
}