package de.ipk_gatersleben.ag_nw.centilib.gui.actions.centralities;

import de.ipk_gatersleben.ag_nw.centilib.CentiLib;
import de.ipk_gatersleben.ag_nw.centilib.centralities.InOutDegree;
import de.ipk_gatersleben.ag_nw.centilib.gui.actions.CentralityAction;
import de.ipk_gatersleben.ag_nw.centilib.utils.CentralityHandler;
import edu.uci.ics.jung.graph.Graph;

/**
 * Computes the degree centrality.
 *
 * @author Johannes Graessler 
 * @author Dirk Koschuetzki
 * @author Michael Telgkamp
 */
@SuppressWarnings("serial")
public class InOutDegreeCentralityAction<V,E> extends CentralityAction<V,E> {

	public InOutDegreeCentralityAction(CentiLib<V,E> centibin) {
		super(centibin, "*** OutDegree");
		scorerName = CentralityHandler.OUTDEGREE;
	}

	public InOutDegreeCentralityAction(CentiLib<V,E> centibin, boolean useInDegree) {
		super(centibin, (useInDegree ? "*** in-" : "*** out-") + "Degree");
		scorerName = (useInDegree ? CentralityHandler.INDEGREE : CentralityHandler.OUTDEGREE);
	}

	public boolean isPossible() {
		return true;
	}

	public static <V,E> InOutDegree<V,E> calculateInOutDegree(Graph<V,E> graph,
			boolean useInDegree) {
		InOutDegree<V,E> iod = new InOutDegree<V,E>(graph,useInDegree);
		return iod;
	}
}