package de.ipk_gatersleben.ag_nw.centilib.gui.actions.centralities;

import org.apache.commons.collections15.Transformer;

import de.ipk_gatersleben.ag_nw.centilib.CentiLib;
import de.ipk_gatersleben.ag_nw.centilib.centralities.BrandesRadiality;
import de.ipk_gatersleben.ag_nw.centilib.centralities.BrandesSP;
import de.ipk_gatersleben.ag_nw.centilib.centralities.VertexCentrality;
import de.ipk_gatersleben.ag_nw.centilib.gui.actions.CentralityAction;
import de.ipk_gatersleben.ag_nw.centilib.utils.CentralityHandler;
import edu.uci.ics.jung.graph.Graph;

/**
 * Computes the radiality centrality.
 *
 * @author Johannes Graessler 
 * @author Dirk Koschuetzki
 * @author Michael Telgkamp
 */
public class RadialityCentralityAction<V,E> extends CentralityAction<V,E> {

    public RadialityCentralityAction(CentiLib<V,E> centibin) {
        super(centibin, "*** Radiality");
        scorerName = CentralityHandler.RADIALITY;
    }

    public static <V,E> VertexCentrality<V,E> calculateRadiality(Graph<V,E> graph, Transformer<E, ? extends Number> edgeWeights) {
    	
    	BrandesRadiality<V,E> rad =  new BrandesRadiality<V, E>(graph);
    	BrandesSP<V,E> brandes;
    	
    	if(edgeWeights != null)
    		brandes = new BrandesSP<V,E>(graph,edgeWeights);
    	else
    		brandes = new BrandesSP<V,E>(graph);
    	
    	brandes.addListener(rad);
    	brandes.start();

//
//    	double diameter = CentralityHandler.getGraphCentralityValue(graph, CentralityHandler.DIAMETER, true);
//    	Radiality<V,E> rad = new Radiality<V,E>(graph,GraphCachingUtils.getDistance(graph),diameter);
//        for(V v : graph.getVertices())
//        	rad.getVertexScore(v);

        return rad;
    }
}