package de.ipk_gatersleben.ag_nw.centilib.gui.actions.graphstatistics;

import java.awt.event.ActionEvent;
import java.util.Collection;
import java.util.List;

import javax.swing.Icon;

import de.ipk_gatersleben.ag_nw.centilib.CentiLib;
import de.ipk_gatersleben.ag_nw.centilib.gui.actions.AssistancePanelAction;
import de.ipk_gatersleben.ag_nw.centilib.utils.CentralityHandler;
import de.ipk_gatersleben.ag_nw.centilib.utils.GraphCachingUtils;
import edu.uci.ics.jung.graph.Graph;

public class ComputeGraphStatisticsAction<V, E> extends
		AssistancePanelAction<V, E> {

	public ComputeGraphStatisticsAction(CentiLib<V, E> centibin, String name,
			Icon icon) {
		super(centibin, "*** Compute Graph Statistics", icon);
		// TODO Auto-generated constructor stub
	}

	public ComputeGraphStatisticsAction(CentiLib<V, E> centibin, String name) {
		super(centibin, name);
		
	}

	@Override
	public void doItInBackground(Collection<Graph<V, E>> graphs,
			List<String> cents) throws Exception {
		
		if(graphs == null||
				graphs.size() == 0 ||
				cents == null ||
				cents.size() == 0)
			return;
			
		String errorMessage = "",
			errors = "\n";
		
		getCentiLib().startLongRunningOperation("", "calculating graph statistics..");
		for(Graph<V,E> graph : graphs){
			errors = "\n";
			for(String cent : cents)
				if(CentralityHandler.isPossible(graph, cent))
					CentralityHandler.getGraphCentralityValue(graph, cent,true);
				else
					errors += "\n   " + cent + "\n"+CentralityHandler.getErrorMessage()+"\n";
			if(!errors.equals("\n"))
				errorMessage += "\n\nGraph "+ GraphCachingUtils.getGraphName(graph)+errors;
		}
		
		getCentiLib().finishedLongRunningOperation();
		if(!errorMessage.equals(""))
			errorMessage = "\nThe following errors occured:" + errorMessage;
		getCentiLib().showInformationDialog("Finished", "Finished calculating the selected value(s)."+errorMessage);
		getCentiLib().refreshPanel();
	}

	@Override
	protected void doItInBackground(ActionEvent e) throws Exception {}
	
	@Override
	public Collection<String> getPossibleCentralities(Collection<Graph<V,E> > graphs){
		return CentralityHandler.getGraphCentList();
	}

}
