package de.ipk_gatersleben.ag_nw.centilib.gui.actions.gui;

import java.awt.event.ActionEvent;

import de.ipk_gatersleben.ag_nw.centilib.CentiLib;
import de.ipk_gatersleben.ag_nw.centilib.gui.actions.GUIAction;
import de.ipk_gatersleben.ag_nw.centilib.utils.GraphCachingUtils;
import edu.uci.ics.jung.algorithms.scoring.VertexScorer;

/**
 * Shows the histogram.
 *
 * @author Johannes Graessler 
 * @author Dirk Koschuetzki
 */
public class ShowCentralityHistogramAction<V,E> extends GUIAction<V,E> {

    public ShowCentralityHistogramAction(CentiLib<V,E> centilib) {
        super(centilib, "*** Show Centrality Histogram");
    }

    public void doItSynchronous(ActionEvent e) {

        VertexScorer<V,Double> ranker = GraphCachingUtils.getLastScorer(getCentiLib().getCurrentGraph());
        if (ranker == null) {
        	getCentiLib().showInformationDialog("Error", "No centrality values found!");
        	return;
        }

        getCentiLib().showCentralityHistogramDialog();
    }
}