package de.ipk_gatersleben.ag_nw.centilib.gui.actions.io;

import java.awt.event.ActionEvent;
import java.io.IOException;
import java.util.Collection;
import java.util.List;

import de.ipk_gatersleben.ag_nw.centilib.CentiLib;
import de.ipk_gatersleben.ag_nw.centilib.centralities.FileBasedRanker;
import de.ipk_gatersleben.ag_nw.centilib.gui.actions.IOAction;
import de.ipk_gatersleben.ag_nw.centilib.io.PajekVectorFiler;
import de.ipk_gatersleben.ag_nw.centilib.utils.CentiLibFileWrapper;
import edu.uci.ics.jung.graph.Graph;

/**
 * Load a vector from a file and display it.
 * 
 * @author Dirk Koschuetzki
 */
public class LoadCentralityVectorAction<V,E> extends IOAction<V,E> {

    public LoadCentralityVectorAction(CentiLib<V,E> centibin) {
        super(centibin, "*** Load Centrality Vector");
    }

    public void doItInBackground(ActionEvent e) throws IOException {
        Graph<V,E> graph = getCentiLib().getCurrentGraph();

        if (graph == null || graph.getVertexCount() == 0) {
            getCentiLib().showInformationDialog("Error", "No graph or vertices found.");
        	return;
        }

        CentiLibFileWrapper cfw = getCentiLib().showOpenVectorDialog();

        if (cfw != null) {

            if (cfw.isPajekVectorFile()) {
                PajekVectorFiler<V,E> filer = new PajekVectorFiler<V,E>();

                FileBasedRanker<V,E> fbRanker = filer.load(graph, cfw.getSelectedFile().getAbsolutePath());
                getCentiLib().setCurrentRanker(fbRanker, "File based ranking");
            }
        }
    }

	@Override
	public void doItInBackground(Collection<Graph<V, E>> graphs,
			List<String> cents) throws Exception {
		// TODO Auto-generated method stub
		
	}
}