package de.ipk_gatersleben.ag_nw.centilib.gui.actions.io;

import java.awt.event.ActionEvent;
import java.util.Collection;
import java.util.List;

import javax.swing.Icon;

import de.ipk_gatersleben.ag_nw.centilib.CentiLib;
import de.ipk_gatersleben.ag_nw.centilib.gui.actions.IOAction;
import de.ipk_gatersleben.ag_nw.centilib.io.TSVFiler;
import de.ipk_gatersleben.ag_nw.centilib.utils.CentiLibFileWrapper;
import edu.uci.ics.jung.graph.Graph;

public class SaveCentralityTableAction<V, E> extends IOAction<V, E> {

	public SaveCentralityTableAction(CentiLib<V, E> centibin, String name,
			Icon icon) {
		super(centibin, "*** Save centrality table", icon);
	}

	public SaveCentralityTableAction(CentiLib<V, E> centibin, String name) {
		super(centibin, name);
	}

	@Override
	public void doItInBackground(Collection<Graph<V, E>> graphs,
			List<String> cents) throws Exception {
		
		String recommendedName = "centrality-tables-for-multiple-graphs";
		boolean result = true;

		try{
			CentiLibFileWrapper cfw = getCentiLib().showSaveTableDialog(recommendedName);
				
			if(cfw == null)
				result = false;
			else
				if(cfw.isTSVVectorFile()){
					TSVFiler<V, E> filer = new TSVFiler<V, E>();
					filer.saveMultipleTables(cfw.getSelectedFile().getAbsolutePath(), graphs, cents, getCentiLib().getVertexLabelTransformer());
				}
		}
		catch(Exception e){
				getCentiLib().showInformationDialog("Error", "Couldn't save the file! Errors:\n\n"+e.getMessage());
				result = false;			
		}
		finally{
			String message;
			if(result)
				message = "Successfully exported all files.";
			else message = "Finished, but some files were skipped (due to an error or by the user).";
			
			getCentiLib().showInformationDialog("Finished", message);
		}
	}

	@Override
	protected void doItInBackground(ActionEvent e) throws Exception {
		// TODO Auto-generated method stub

	}

}
