package de.ipk_gatersleben.ag_nw.centilib.gui.actions.io;

import java.awt.event.ActionEvent;
import java.util.Collection;
import java.util.List;

import javax.swing.Icon;

import de.ipk_gatersleben.ag_nw.centilib.CentiLib;
import de.ipk_gatersleben.ag_nw.centilib.gui.actions.AssistancePanelAction;
import de.ipk_gatersleben.ag_nw.centilib.io.TSVFiler;
import de.ipk_gatersleben.ag_nw.centilib.utils.CentiLibFileWrapper;
import de.ipk_gatersleben.ag_nw.centilib.utils.GraphCachingUtils;
import edu.uci.ics.jung.graph.Graph;

public class SaveMultipleCentralityTablesAction<V, E> extends
		AssistancePanelAction<V, E> {

	public SaveMultipleCentralityTablesAction(CentiLib<V, E> centibin,
			String name, Icon icon) {
		super(centibin, "*** Save Multiple Centrality Tables", icon);
		// TODO Auto-generated constructor stub
	}

	public SaveMultipleCentralityTablesAction(CentiLib<V, E> centibin,
			String name) {
		super(centibin, name);
	}

	@Override
	public void doItInBackground(Collection<Graph<V, E>> graphs,
			List<String> cents) throws Exception {

		String recommendedName = "";
		boolean result = true;
		
		for(Graph<V,E> g : graphs){
			recommendedName = "centralities for '" + GraphCachingUtils.getGraphName(g).replace('*', ' ') + "'.tsv";
			try{
				CentiLibFileWrapper cfw = getCentiLib().showSaveTableDialog(recommendedName);
				if(cfw == null){
					//centilib.showInformationDialog("Error", "Couldn't save the file");
					result = false;
					continue;
				}
				if(cfw.isTSVVectorFile()){
					TSVFiler<V, E> filer = new TSVFiler<V, E>();
					filer.saveTable(cfw.getSelectedFile().getAbsolutePath(), g, cents, getCentiLib().getVertexLabelTransformer());
				}
			}
			catch(Exception ex){
				getCentiLib().showInformationDialog("Error", "Couldn't save the file! Errors:\n\n"+ex.getMessage());
				result = false;
			}
		}
		
		String message;
		if(result)
			message = "Successfully exported all files.";
		else message = "Finished, but some files were skipped (due to an error or by the user).";
		
		getCentiLib().showInformationDialog("Finished", message);
	}

	@Override
	protected void doItInBackground(ActionEvent e) throws Exception {
		// TODO Auto-generated method stub

	}

}
