package de.ipk_gatersleben.ag_nw.centilib.utils;


public interface BrandesSPListener<V,E> {

	/**
	 * 
	 * Implement this class if you want to compute a centrality which is based on partial dependencies. After creating an Object
	 * of this Interface, it can listen to an instance of the class BrandesSP.
	 *  
	 * Be sure to keep stepData unchanged for performance reasons. If stepData is changed, the original data has to be copied
	 * for other centralities again.
	 * 
	 * @param stepData The shortest paths and dependencies computed by BrandesSP
	 */
	public void computeDependencies(BrandesSPData<V, E> stepData);
	
	public void finished();
}
