package de.ipk_gatersleben.ag_nw.centilib.utils;

import java.io.File;

public class CentiLibFileWrapper {

    private File selectedFile;

    public CentiLibFileWrapper(File selectedFile) {
        this.selectedFile = selectedFile;
    }

    public boolean isPajekNetFile() {
        return getSelectedFile().getName().toLowerCase().endsWith(".net");
    }

    public boolean isGraphMLFile() {
        return getSelectedFile().getName().toLowerCase().endsWith(".xml");
    }

    public boolean isAdjMatrixFile() {
        return getSelectedFile().getName().toLowerCase().endsWith(".mat");
    }

    public boolean isDIPFile() {
        return getSelectedFile().getName().toLowerCase().endsWith(".tab");
    }

    public boolean isBINDFile() {
        return getSelectedFile().getName().toLowerCase().endsWith(".bind");
    }

    public boolean isXWGFile() {
        return getSelectedFile().getName().toLowerCase().endsWith(".xwg");
    }

    public boolean isDOTFile() {
        return getSelectedFile().getName().toLowerCase().endsWith(".dot");
    }

    public boolean isPajekVectorFile() {
        return getSelectedFile().getName().toLowerCase().endsWith(".vec");
    }

    public boolean isTSVVectorFile() {
        return getSelectedFile().getName().toLowerCase().endsWith(".tsv");
    }

    public File getSelectedFile() {
        return selectedFile;
    }

    public String getFilenameWithoutExtension() {
        if (isPajekNetFile()) {
            return getSelectedFile().getName().substring(0, getSelectedFile().getName().length() - 4);
        }

        if (isGraphMLFile()) {
            return getSelectedFile().getName().substring(0, getSelectedFile().getName().length() - 4);
        }

        if (isAdjMatrixFile()) {
            return getSelectedFile().getName().substring(0, getSelectedFile().getName().length() - 4);
        }

        if (isDIPFile()) {
            return getSelectedFile().getName().substring(0, getSelectedFile().getName().length() - 4);
        }

        if (isBINDFile()) {
            return getSelectedFile().getName().substring(0, getSelectedFile().getName().length() - 4);
        }

        if (isXWGFile()) {
            return getSelectedFile().getName().substring(0, getSelectedFile().getName().length() - 4);
        }

        if (isDOTFile()) {
            return getSelectedFile().getName().substring(0, getSelectedFile().getName().length() - 4);
        }

        if (isPajekVectorFile()) {
            return getSelectedFile().getName().substring(0, getSelectedFile().getName().length() - 4);
        }

        if (isTSVVectorFile()) {
            return getSelectedFile().getName().substring(0, getSelectedFile().getName().length() - 4);
        }
        return getSelectedFile().getName();
    }
}
