package de.ipk_gatersleben.ag_nw.centilib.utils;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.HeadlessException;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.io.PrintWriter;
import java.io.StringWriter;

import javax.swing.AbstractAction;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;

/**
 * The dialog showing an exception.
 * 
 * @author Dirk Koschuetzki
 */
@SuppressWarnings("serial")
public class ErrorHandlerDialog extends JDialog {

    JLabel descriptionL = new JLabel();

    JTextField errorMsg = new JTextField();

    JTextArea errorTextArea = new JTextArea();

    JButton continueButton;

    public ErrorHandlerDialog(JFrame parent) throws HeadlessException {

        super(parent, "CentiLib: An error occured", true);

        continueButton = new JButton(new ContinueAction(this));

        getContentPane().add(createPanel());
        //setLayout(new BorderLayout());
        setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        this.setSize(new Dimension(600, 400));
        getRootPane().setDefaultButton(continueButton);
    }

    public void showException(Throwable e) {
        errorMsg.setText(e.getMessage());
        StringWriter sw = new StringWriter();
        PrintWriter pw = new PrintWriter(sw);
        e.printStackTrace(pw);
        pw.close();
        errorTextArea.setText(sw.toString());
        validate();
		//JOptionPane.showMessageDialog(this.getParent(), "validated");
        setVisible(true);
    }

    private Component createPanel() {
        JPanel p = new JPanel();
        p.setLayout(new GridBagLayout());

        descriptionL.setText("<html><h1><center>An error occured...</center></h1>"
                + "<p>Please check the message below and if you think this is a bug "
                + "send an email to <tt>koschuet@ipk-gatersleben.de</tt> and "
                + "copy the content of the bottom textfield into the email.</p><br>" + "<p>Thank you.</p></html>");

        GridBagConstraints gbc = new GridBagConstraints();
        errorMsg.setEditable(false);
        errorTextArea.setEditable(false);

        gbc.gridx = 0;
        gbc.gridy = GridBagConstraints.RELATIVE;
        gbc.gridwidth = 2;
        gbc.fill = GridBagConstraints.BOTH;
        gbc.weightx = 1;
        gbc.weighty = 0;
        gbc.insets = new Insets(10, 10, 10, 10);
        p.add(descriptionL, gbc);
        p.add(errorMsg, gbc);
        gbc.weighty = 1;
        p.add(errorTextArea, gbc);

        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth = 1;
        gbc.weighty = 0;
        gbc.gridx = 0;
        p.add(continueButton, gbc);

        return p;
    }

    private class ContinueAction extends AbstractAction {
        JDialog parent;

        public ContinueAction(JDialog parent) {
            super("Continue");
            this.parent = parent;
        }

        public void actionPerformed(ActionEvent e) {
            parent.setVisible(false);
        }
    }

}